/*
 * The Disc class contains the information about a disc.
 * The information consists of:
 * -int column
 * -int row
 * -Player owner
 * 
 * The class also manages the disc animation and sound.
 */
package Game;

import java.net.URL;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;

/**
 * @author RJW Jonk
 */
public class Disc {

    //Variables
    //Position variables
    private int column;
    private int row;
    //Owner
    private Player owner;

    /**
     * 
     * @param c Column
     * @param r Row
     * @param o Owner of the disc
     */
    Disc(int c, int r, Player o) {
        column = c;
        row = r;
        owner = o;
    }

    //Getters

    /**
     * Function to get the column of the disc
     * @return column
     */
    public int getColumn() {
        return column;
    }

    /**
     * Function to get the row of the disc
     * @return row
     */
    public int getRow() {
        return row;
    }

    /**
     * Function to get the owner of the disc
     * @return owner
     */
    public Player getOwner() {
        return owner;
    }


    /**
     * Plays the sound.
     */
    public void playSound() {
        try {
            URL ais = this.getClass().getResource("/GUI/resources/dropdisc.wav");
            AudioInputStream audioIn = AudioSystem.getAudioInputStream(ais);
            // Get a sound clip resource.
            Clip clip = AudioSystem.getClip();
            // Open audio clip and load samples from the audio input stream.
            clip.open(audioIn);
            clip.start();
        } catch (Exception e) {
            //e.printStackTrace();
        }
    }

    /* Implemented in Game, this one can be removed */
    /**
     * Pre: true
     * Post: The movement has been animated
     */
    public void animateMovement() {
        //TODO Implement code
    }
}
