package Game;

import ScoreManagement.User;
import GUI.Game;
import java.util.concurrent.Semaphore;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

public class HumanPlayer extends Player {

    private Semaphore waithandle = new Semaphore(0);
    public int selectedColumn = 0;
    private Boolean acceptInput = false;

    public HumanPlayer(Game game, User user, String color) {
        super(game, user, color);
    }

    /**
     * Function to place a new disc in the playing field and to check if the move is done successfully.
     * @param c Column a new disc is played in.
     * @return True if the disc is placed in the field, false otherwise.
     */
    @Override
    public boolean putDisc(int c) {
        if (acceptInput && super.putDisc(c)) {
            acceptInput = false;
            waithandle.release();
            return true;
        } else {
            // Disc cannot be inserted, show a message column is full
            if (acceptInput) {
                JOptionPane.showMessageDialog(null, "The selected column is full");
            }
            return false;
        }
    }

    /**
     * Function to enable the controls of the player.
     */
    @Override
    public void doMove() {
        acceptInput = true;
        try {
            waithandle.acquire();
        } catch (InterruptedException ex) {
        }
    }
}
